const LATIN_ALPHABET: &str = "abcdefghijklmnopqrstuvwxyz";

use std::io;
use std::io::*;
use std::process;
use random_word;

#[derive(Debug)]
struct GameData<'a> {
    word: String,
    lives: u16,
    alphabet: &'a str,
    letters_tried: Vec<char>,
    letters_found: Vec<char>,
}

impl GameData<'static> {
    fn new() -> GameData<'static> {
        Self {
            word: String::from(random_word::gen()),
            lives: 10,
            alphabet: LATIN_ALPHABET,
            letters_tried: Vec::new(),
            letters_found: Vec::new(),
        }
    }

    fn play(&mut self, letter: &char) {
        if self.letters_tried.contains(letter) {
            println!("Already tried this letter !");
        } else {
            self.letters_tried.push(letter.clone());
            if self.word.chars().collect::<Vec<char>>().contains(letter) {
                println!("YES");
                self.letters_found.push(letter.clone());
            } else {
                println!("NO");
                self.lives -= 1;
            }
        }
    }

    fn end_turn(&self) {
        let mut printme = String::new();
        for letter in self.word.chars() {
            if self.letters_found.contains(&letter) {
                printme.push(letter);
            } else {
                printme.push('_');
            }
        }
        println!("{}", printme);

        if !printme.chars().collect::<Vec<char>>().contains(&'_') {
            println!("You won ! You're soooo smart.");
            process::exit(0);
        }
    }


}

fn main() { 
    let mut my_game = GameData::new();
    println!("IM A BORED SYSADMIN\n\nTry to find the word, he\n\n");
    let stdin = io::stdin();

    loop {
        //Dead ?
        if &my_game.lives < &1 {
            println!("The word was {:?}", &my_game.word);
            println!("You died, sucker");
            process::exit(0);
        }

        //Alive !
        let mut user_input = String::new();
        print!("Letter > ");
        stdin.read_line(&mut user_input).unwrap();
        let tried = user_input
            .to_lowercase()
            .chars()
            .collect::<Vec<char>>()
            .first()
            .unwrap_or(&'a')
            .clone();
        *&mut my_game.play(&tried);
        println!("===> {:?}, LIVES {}", my_game.letters_tried, my_game.lives);
        my_game.end_turn();
    }
        
}
